#ifndef LINT
static char *rcsid="$Id: answer.c,v 1.4 1999/12/28 16:01:53 crosser Exp $";
#endif

/*
	"ifmail": FidoNet(r) support package for UN*X platform

	Copyright (c) 1993-1999 Eugene G. Crosser

	You may distribute and/or use for any purpose modified or unmodified
	copies of this software if you preserve the copyright notice above.

	THIS SOFTWARE IS PROVIDED AS IS AND COME WITH NO WARRANTY OF ANY
	KIND, EITHER EXPRESSED OR IMPLIED.  IN NO EVENT WILL THE
	COPYRIGHT HOLDER BE LIABLE FOR ANY DAMAGES RESULTING FROM THE
	USE OF THIS SOFTWARE.

	URL: http://www.average.org/ifmail/
	E-Mail: <crosser@average.org>
*/

/*
	$Log: answer.c,v $
	Revision 1.4  1999/12/28 16:01:53  crosser
	Move to syslog
	Portability for HP/UX
	
	Revision 1.3  1999/12/28 06:37:27  crosser
	Make TCP slave/daemon and master modes work
	
	Revision 1.2  1999/09/12 23:24:30  crosser
	Clean tests
	Work in progress on daemon mode
	
	Revision 1.1.1.1  1999/08/29 22:53:46  crosser
	Ifmail
	
*/

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <sys/types.h>
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif
#include <stdio.h>
#ifdef STDC_HEADERS
# include <stdlib.h>
# include <string.h>
#else
# ifdef HAVE_STRINGS_H
#  include <strings.h>
# endif
#endif
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif

#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include "lutil.h"
#include "ftn.h"
#include "nodelist.h"
#include "session.h"
#include "rdconfig.h"

extern int rawport(void);
extern void nolocalport(void);
extern int cookedport(void);
extern void rdoptions(node *);

int answer(stype)
char *stype;
{
	int st,rc;
	node *nlent;
	char *p;

	debug(10,"entering answer(\"%s\")",S(stype));

	if ((p=ttyname(0))) {
		if ((p=strrchr(ttyname(0),'/'))) p++;
		setnamesfx(p);
	}

	if ((nlent=getnlent(NULL)) == NULL)
	{
		syslog(LOG_ERR,"could not get dummy nodelist entry");
		return 1;
	}

	rdoptions(nlent);

	inbound=norminbound; /* slave session is unsecure by default */

	if (stype == NULL)
		st=SESSION_UNKNOWN;
	else if (strcmp(stype,"tsync") == 0)
		st=SESSION_FTSC;
	else if (strcmp(stype,"yoohoo") == 0)
		st=SESSION_YOOHOO;
	else if (strncmp(stype,"**EMSI_",7) == 0)
		st=SESSION_EMSI;
	else
		st=SESSION_UNKNOWN;
	debug(10,"answer to \"%s\" (%d) call",stype?stype:"unknown type",st);

	if ((rc=rawport()) != 0)
		syslog(LOG_ERR,"unable to set raw mode");
	else
	{
		nolocalport();
		rc=session(NULL,NULL,SESSION_SLAVE,st,stype);
	}

	cookedport();
	return rc;
}
