#ifndef LINT
static char *rcsid="$Id: dietifna.c,v 1.1.1.1 1999/08/29 22:53:46 crosser Exp $";
#endif

/*
	"ifmail": FidoNet(r) support package for UN*X platform

	Copyright (c) 1993-1999 Eugene G. Crosser

	You may distribute and/or use for any purpose modified or unmodified
	copies of this software if you preserve the copyright notice above.

	THIS SOFTWARE IS PROVIDED AS IS AND COME WITH NO WARRANTY OF ANY
	KIND, EITHER EXPRESSED OR IMPLIED.  IN NO EVENT WILL THE
	COPYRIGHT HOLDER BE LIABLE FOR ANY DAMAGES RESULTING FROM THE
	USE OF THIS SOFTWARE.

	URL: http://www.average.org/ifmail/
	E-Mail: <crosser@average.org>
*/

/*
	$Log: dietifna.c,v $
	Revision 1.1.1.1  1999/08/29 22:53:46  crosser
	Ifmail
	
*/

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <sys/types.h>
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif
#include <stdio.h>
#ifdef STDC_HEADERS
# include <stdlib.h>
# include <string.h>
#else
# ifdef HAVE_STRINGS_H
#  include <strings.h>
# endif
#endif
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif

#include <stdlib.h>
#include "lutil.h"
#include "ttyio.h"
#include "session.h"
#include "emsi.h"

extern int made_request;
static int sendfiles(file_list*);
extern int xmsndfiles(file_list*);
static int xmrcvfiles(void);
extern int xmrecv(char*);
extern file_list *respond_wazoo(char*);

int rxdietifna(void);
int rxdietifna(void)
{
	int rc;
	file_list *tosend=NULL,**tmpfl;

	debug(10,"start rxDietIFNA");
	session_flags |= SESSION_IFNA;
	session_flags &= ~SESSION_BARK;
	tosend=create_filelist(remote,ALL_MAIL,0);
	if ((rc=xmrcvfiles()) == 0)
	{
		if ((emsi_local_opts & NRQ) == 0)
		{
			for (tmpfl=&tosend;*tmpfl;tmpfl=&((*tmpfl)->next));
			*tmpfl=respond_wazoo(NULL);
		}
		rc=sendfiles(tosend);
		/* we are not sending file requests in slave session */
	}
	tidy_filelist(tosend,(rc == 0));
	debug(10,"rxdietifna transfer rc=%d",rc);
	return rc;
}

int txdietifna(void);
int txdietifna(void)
{
	int rc;
	file_list *tosend=NULL,*respond=NULL;
	char *nonhold_mail;

	debug(10,"start txDietIFNA");
	session_flags |= SESSION_IFNA;
	session_flags &= ~SESSION_BARK;
	if (localoptions & NOHOLD) nonhold_mail=ALL_MAIL;
	else nonhold_mail=NONHOLD_MAIL;
	tosend=create_filelist(remote,nonhold_mail,2);

	if ((rc=sendfiles(tosend)) == 0)
		if ((rc=xmrcvfiles()) == 0)
			if ((emsi_local_opts & NRQ) == 0)
				if ((respond=respond_wazoo(NULL)))
					rc=sendfiles(respond);
	/* but we are trying to respond other's file requests in master */
	/* session, though they are not allowed by the DietIFNA protocol */
	
	tidy_filelist(tosend,(rc == 0));
	tidy_filelist(respond,0);
	debug(10,"rxdietifna transfer rc=%d",rc);
	return rc;
}

int xmrcvfiles(void)
{
	int rc;

	while ((rc=xmrecv(NULL)) == 0);
	if (rc == 1) return 0;
	else return rc;
}

int sendfiles(tosend)
file_list *tosend;
{
	int c,count;

	count=0;
	while (((c=GETCHAR(15)) >= 0) && (c != NAK) && (c != 'C') && 
	       (count++ < 9)) 
		debug(11,"got '%s' waiting for C/NAK",
			printablec(c));
	if (c == NAK)
	{
		session_flags &= ~FTSC_XMODEM_CRC;
	}
	else if (c == 'C')
	{
		session_flags |= FTSC_XMODEM_CRC;
	}
	else if (c < 0) return c;
	else return 1;

	return xmsndfiles(tosend);
}
