#ifndef LINT
static char *rcsid="$Id: filetime.c,v 1.2 1999/08/30 16:43:15 crosser Exp $";
#endif

/*
	"ifmail": FidoNet(r) support package for UN*X platform

	Copyright (c) 1993-1999 Eugene G. Crosser

	You may distribute and/or use for any purpose modified or unmodified
	copies of this software if you preserve the copyright notice above.

	THIS SOFTWARE IS PROVIDED AS IS AND COME WITH NO WARRANTY OF ANY
	KIND, EITHER EXPRESSED OR IMPLIED.  IN NO EVENT WILL THE
	COPYRIGHT HOLDER BE LIABLE FOR ANY DAMAGES RESULTING FROM THE
	USE OF THIS SOFTWARE.

	URL: http://www.average.org/ifmail/
	E-Mail: <crosser@average.org>
*/

/*
	$Log: filetime.c,v $
	Revision 1.2  1999/08/30 16:43:15  crosser
	Make the thing at least compile.
	
	Revision 1.1.1.1  1999/08/29 22:53:46  crosser
	Ifmail
	
*/

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <sys/types.h>
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif
#include <stdio.h>
#ifdef STDC_HEADERS
# include <stdlib.h>
# include <string.h>
#else
# ifdef HAVE_STRINGS_H
#  include <strings.h>
# endif
#endif
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif

#include <sys/types.h>
#include <time.h>

time_t mtime2sl(time_t);
time_t sl2mtime(time_t);
time_t mtime2tl(time_t);
time_t tl2mtime(time_t);

time_t gmtoff(time_t);
time_t gmtoff(tt)
time_t tt;
{
	struct tm lt;
#ifndef HAVE_TM_GMTOFF
	struct tm gt;
	time_t offset;

	lt=*localtime(&tt);
	gt=*gmtime(&tt);
	offset=gt.tm_yday-lt.tm_yday;
	if (offset > 1) offset=-24;
	else if (offset < -1) offset=24;
	else offset*=24;
	offset+=gt.tm_hour-lt.tm_hour;
	offset*=60;
	offset+=gt.tm_min-lt.tm_min;
	offset*=60;
	offset+=gt.tm_sec-lt.tm_sec;
	return offset;
#else
	lt=*localtime(&tt);
	return lt.tm_gmtoff;
#endif
}

time_t mtime2sl(tt)
time_t tt;
{
	return tt-gmtoff(tt);
}
time_t sl2mtime(tt)
time_t tt;
{
	return tt+gmtoff(tt);
}
time_t mtime2tl(tt)
time_t tt;
{
	time_t tlt=0L;
	struct tm *tm;

	tm=localtime(&tt);
	tlt |= ((tm->tm_year)-1980)<<25;
	tlt |= (tm->tm_mon)<<21;
	tlt |= (tm->tm_mday)<<16;
	tlt |= (tm->tm_hour)<<11;
	tlt |= (tm->tm_min)<<5;
	tlt |= (tm->tm_sec)>>1;
	return tlt;
}
time_t tl2mtime(tt)
time_t tt;
{
	struct tm tm;

	tm.tm_year= ((tt>>25)&0x7f)+1980;
	tm.tm_mon=  (tt>>21)&0x0f;
	tm.tm_mday=  (tt>>16)&0x1f;
	tm.tm_hour= (tt>>11)&0x1f;
	tm.tm_min=  (tt>>5 )&0x3f;
	tm.tm_sec=  ((tt    )&0x1f)*2;
	return mktime(&tm);
}
