/*
	$Id: fsm.h,v 1.3 1999/12/28 16:01:53 crosser Exp $
*/

/*
	"ifmail": FidoNet(r) support package for UN*X platform

	Copyright (c) 1993-1999 Eugene G. Crosser

	You may distribute and/or use for any purpose modified or unmodified
	copies of this software if you preserve the copyright notice above.

	THIS SOFTWARE IS PROVIDED AS IS AND COME WITH NO WARRANTY OF ANY
	KIND, EITHER EXPRESSED OR IMPLIED.  IN NO EVENT WILL THE
	COPYRIGHT HOLDER BE LIABLE FOR ANY DAMAGES RESULTING FROM THE
	USE OF THIS SOFTWARE.

	URL: http://www.average.org/ifmail/
	E-Mail: <crosser@average.org>
*/

/*
	$Log: fsm.h,v $
	Revision 1.3  1999/12/28 16:01:53  crosser
	Move to syslog
	Portability for HP/UX
	
	Revision 1.2  1999/12/20 21:53:46  crosser
	Added Janus implementation by Kolya Nesterov, 2:463/567@fidonet
	(patch for 3.02 made by Vladimir Zarozhevsky)
	
	Revision 1.1.1.1  1999/08/29 22:53:46  crosser
	Ifmail
	
*/
#ifndef FSM_H
#define FSM_H

/*
   Finite State Machine.  Replace oldish "statetbl.h", use '#'
   preprocessor feature, detach state machine from function definition.
   Although, multi-machine (with more than one state variable)
   not implemented, so bidirectional protos will not use this.
*/

#define SM_STATES(name) \
	int sm_success=0;\
	char *sm_name=name; \
	enum {

#define SM_ESTATES \
	} sm_state;

#define SM_START(x) \
	sm_state=x;\
	debug(14,"statemachine %s start %s (%d)",sm_name,#x,x);\
	while (!sm_success) switch (sm_state)\
	{\
	default: syslog(LOG_ERR,"statemachine %s error: state=%d",sm_name,sm_state);\
		sm_success=-1;

#define SM_STATE(x) \
	break;\
	case x: debug(15,"statemachine %s entering %s (%d)",\
		sm_name,#x,x);

#define SM_END \
	}\
	debug(14,"statemachine %s exit %s (%d)",\
		sm_name,(sm_success == -1)?"error":"success",sm_success);

#define SM_RETURN \
	return (sm_success != 1);\
}

#define SM_PROCEED(x) \
	sm_state=x; break;

#define SM_SUCCESS \
	sm_success=1; break;

#define SM_ERROR \
	sm_success=-1; break;

#endif
