#ifndef LINT
static char *rcsid="$Id: m7send.c,v 1.2 1999/12/28 16:01:54 crosser Exp $";
#endif

/*
	"ifmail": FidoNet(r) support package for UN*X platform

	Copyright (c) 1993-1999 Eugene G. Crosser

	You may distribute and/or use for any purpose modified or unmodified
	copies of this software if you preserve the copyright notice above.

	THIS SOFTWARE IS PROVIDED AS IS AND COME WITH NO WARRANTY OF ANY
	KIND, EITHER EXPRESSED OR IMPLIED.  IN NO EVENT WILL THE
	COPYRIGHT HOLDER BE LIABLE FOR ANY DAMAGES RESULTING FROM THE
	USE OF THIS SOFTWARE.

	URL: http://www.average.org/ifmail/
	E-Mail: <crosser@average.org>
*/

/*
	$Log: m7send.c,v $
	Revision 1.2  1999/12/28 16:01:54  crosser
	Move to syslog
	Portability for HP/UX
	
	Revision 1.1.1.1  1999/08/29 22:53:46  crosser
	Ifmail
	
*/

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <sys/types.h>
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif
#include <stdio.h>
#ifdef STDC_HEADERS
# include <stdlib.h>
# include <string.h>
#else
# ifdef HAVE_STRINGS_H
#  include <strings.h>
# endif
#endif
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif

#include <ctype.h>
#include <string.h>
#include "statetbl.h"
#include "ttyio.h"
#include "lutil.h"

static int m7_send(void);

static char *fn;

int m7send(char*);
int m7send(fname)
char *fname;
{
	fn=fname;
	return m7_send();
}

SM_DECL(m7_send,"m7send")
SM_STATES
	waitnak,sendack,sendchar,waitack,sendsub,
	waitcheck,ackcheck
SM_NAMES
	"waitnak","sendack","sendchar","waitack","sendsub",
	"waitcheck","ackcheck"
SM_EDECL

	char buf[12],*p;
	int i,c,count=0;
	char cs=SUB;

	memset(buf,' ',sizeof(buf));
	for (i=0,p=fn;(i<8) && (*p) && (*p != '.');i++,p++)
		buf[i]=toupper(*p);
	if (*p == '.') p++;
	for (;(i<11) && (*p);i++,p++)
		buf[i]=toupper(*p);
	for (i=0;i<11;i++)
		cs+=buf[i];
	buf[11]='\0';
	debug(11,"modem7 filename \"%s\", checksum %02x",
		buf,(unsigned char)cs);

SM_START(sendack)

SM_STATE(waitnak)

	if (count++ > 6)
	{
		syslog(LOG_INFO,"too many tries sending modem7 name");
		SM_ERROR;
	}

	c=GETCHAR(15);
	if (c == TIMEOUT)
	{
		debug(11,"m7 got timeout waiting NAK");
		SM_PROCEED(waitnak);
	}
	else if (c < 0)
	{
		SM_ERROR;
	}
	else if (c == NAK)
	{
		SM_PROCEED(sendack);
	}
	else
	{
		debug(11,"m7 got '%s' waiting NAK",
			printablec(c));
		PUTCHAR('u');
		SM_PROCEED(waitnak);
	}


SM_STATE(sendack)

	i=0;
	PUTCHAR(ACK);
	if (STATUS) {SM_ERROR;}
	else {SM_PROCEED(sendchar)};

SM_STATE(sendchar)

	if (i > 11) {SM_PROCEED(sendsub);}

	PUTCHAR(buf[i++]);
	if (STATUS) {SM_ERROR;}
	else {SM_PROCEED(waitack)};

SM_STATE(waitack)

	c=GETCHAR(15);
	if (c == TIMEOUT)
	{
		debug(11,"m7 got timeout waiting ACK for char %d",i);
		PUTCHAR('u');
		SM_PROCEED(waitnak);
	}
	else if (c < 0)
	{
		SM_ERROR;
	}
	else if (c == ACK)
	{
		SM_PROCEED(sendchar);
	}
	else
	{
		debug(11,"m7 got '%s' waiting ACK for char %d",
			printablec(c),i);
		PUTCHAR('u');
		SM_PROCEED(waitnak);
	}

SM_STATE(sendsub)

	PUTCHAR(SUB);
	SM_PROCEED(waitcheck);

SM_STATE(waitcheck)

	c=GETCHAR(15);
	if (c == TIMEOUT)
	{
		debug(11,"m7 got timeout waiting check");
		PUTCHAR('u');
		SM_PROCEED(waitnak);
	}
	else if (c < 0)
	{
		SM_ERROR;
	}
	else if (c == cs)
	{
		SM_PROCEED(ackcheck);
	}
	else
	{
		debug(11,"m7 got %02x waiting check %02x",
			(unsigned char)c,(unsigned char)cs);
		PUTCHAR('u');
		SM_PROCEED(waitnak);
	}

SM_STATE(ackcheck)

	PUTCHAR(ACK);
	if (STATUS) {SM_ERROR;}
	else {SM_SUCCESS;}

SM_END
SM_RETURN
