#ifndef LINT
static char *rcsid="$Id: nlpatch.c,v 1.6 1999/12/29 23:16:54 crosser Exp $";
#endif

/*
	"ifmail": FidoNet(r) support package for UN*X platform

	Copyright (c) 1993-1999 Eugene G. Crosser

	You may distribute and/or use for any purpose modified or unmodified
	copies of this software if you preserve the copyright notice above.

	THIS SOFTWARE IS PROVIDED AS IS AND COME WITH NO WARRANTY OF ANY
	KIND, EITHER EXPRESSED OR IMPLIED.  IN NO EVENT WILL THE
	COPYRIGHT HOLDER BE LIABLE FOR ANY DAMAGES RESULTING FROM THE
	USE OF THIS SOFTWARE.

	URL: http://www.average.org/ifmail/
	E-Mail: <crosser@average.org>
*/

/*
	$Log: nlpatch.c,v $
	Revision 1.6  1999/12/29 23:16:54  crosser
	make syslog and debug use %m for error message
	
	Revision 1.5  1999/12/28 16:01:54  crosser
	Move to syslog
	Portability for HP/UX
	
	Revision 1.4  1999/11/26 18:11:36  crosser
	Tune for sunos4
	
	Revision 1.3  1999/08/30 22:56:02  crosser
	dbm checks et al
	
	Revision 1.2  1999/08/30 16:43:15  crosser
	Make the thing at least compile.
	
	Revision 1.1.1.1  1999/08/29 22:53:46  crosser
	Ifmail
	
*/

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <sys/types.h>
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif
#include <stdio.h>
#ifdef STDC_HEADERS
# include <stdlib.h>
# include <string.h>
#else
# ifdef HAVE_STRINGS_H
#  include <strings.h>
# endif
#endif
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif
#ifndef OPTARG_DEFINED
#include <getopt.h>
#endif
#ifdef HAVE_SYSLOG
#include <syslog.h>
#endif

#include "mygetopt.h"
#include "xutil.h"
#include "lutil.h"
#include "rdconfig.h"

#ifndef BLKSIZ
#define BLKSIZ 512
#endif

extern unsigned INT16 crc16tab[];
#define updcrc(cp, crc) ( crc16tab[((crc >> 8) & 255) ^ cp] ^ (crc << 8))

void usage(void)
{
	confusage("<nodelist> <nodediff>");
}

static int apply(char*,char*,char*);

int main(argc,argv)
int argc;
char *argv[];
{
	int c,rc;
	char *nl,*nd,*nn;
	char *p,*q;

#if defined(HAVE_SYSLOG) && defined(CICOLOG)
	logfacility=CICOLOG;
#endif

	setmyname(argv[0]);
	while ((c=getopt(argc,argv,"x:I:h")) != -1)
	if (confopt(c,optarg)) switch (c)
	{
		default:	usage(); exit(1);
	}

	if (((nl=argv[optind++]) == NULL) ||
	    ((nd=argv[optind++]) == NULL) ||
	    (argv[optind]))
	{
		usage(); exit(1);
	}

	if ((rc=readconfig()))
	{
		fprintf(stderr,"Error getting configuration, aborting\n");
		return rc;
	}

	if (((p=strrchr(nl,'.'))) && ((q=strrchr(nd,'.'))) &&
	    (strlen(p) == strlen(q)))
	{
		nn=xstrcpy(nl);
		p=strrchr(nn,'.')+1;
		q++;
		strcpy(p,q);
	}
	else nn=xstrcpy("newnodelist");
	syslog(LOG_INFO,"patching %s with %s to %s",nl,nd,nn);
	rc=apply(nl,nd,nn);
	if (rc) unlink(nn);
	free(nn);

	return rc;
}

int apply(nl,nd,nn)
char *nl,*nd,*nn;
{
	FILE *fo,*fd,*fn;
	unsigned char cmdbuf[BLKSIZ];
	unsigned char lnbuf[BLKSIZ];
	int i,count;
	int ac=0,cc=0,dc=0;
	int rc=0;
	int firstline=1;
	unsigned INT16 theircrc=0,mycrc=0;
	unsigned char *p;

	if (((fo=fopen(nl,"r")) == NULL) ||
	    ((fd=fopen(nd,"r")) == NULL) ||
	    ((fn=fopen(nn,"w")) == NULL))
	{
		syslog(LOG_ERR,"cannot open some file(s): %m");
		return 2;
	}

	if ((fgets(cmdbuf,sizeof(cmdbuf)-1,fd) == NULL) ||
	    (fgets(lnbuf,sizeof(cmdbuf)-1,fo) == NULL) ||
	    (strcmp(cmdbuf,lnbuf) != 0))
	{
		rc=6;
	}
	else
	{
		rewind(fo);
		rewind(fd);
		while ((rc == 0) && fgets(cmdbuf,sizeof(cmdbuf)-1,fd))
		switch (cmdbuf[0])
		{
		case ';':
			debug(20,"COM: %s",cmdbuf);
			break;
		case 'A':
			count=atoi(cmdbuf+1);
			ac+=count;
			debug(20,"ADD %d: %s",count,cmdbuf);
			for (i=0;(i < count) && (rc == 0);i++)
			if (fgets(lnbuf,sizeof(lnbuf)-1,fd))
			{
				if (firstline)
				{
					firstline=0;
					if ((p=strrchr(lnbuf,':')))
					{
						theircrc=atoi(p+1);
					}
				}
				else
				{
					for (p=lnbuf;*p;p++)
						mycrc=updcrc(*p,mycrc);
				}
				fputs(lnbuf,fn);
			}
			else rc=3;
			break;
		case 'D':
			count=atoi(cmdbuf+1);
			dc+=count;
			debug(20,"DEL %d: %s",count,cmdbuf);
			for (i=0;(i < count) && (rc == 0);i++)
			if (fgets(lnbuf,sizeof(lnbuf)-1,fo) == NULL) rc=3;
			break;
		case 'C':
			count=atoi(cmdbuf+1);
			cc+=count;
			debug(20,"CPY %d: %s",count,cmdbuf);
			for (i=0;(i < count) && (rc == 0);i++)
			if (fgets(lnbuf,sizeof(lnbuf)-1,fo))
			{
				for (p=lnbuf;*p;p++)
					mycrc=updcrc(*p,mycrc);
				fputs(lnbuf,fn);
			}
			else rc=3;
			break;
		default:
			rc=5;
			break;
		}
	}

	fclose(fo);
	fclose(fd);
	fclose(fn);

	debug(20,"theircrc=%hu, mycrc=%hu",theircrc,mycrc);

	if ((rc == 0) && (mycrc != theircrc)) rc=4;

	if (rc == 3)
		syslog(LOG_INFO,"could not read some of the files");
	else if (rc == 4)
		syslog(LOG_INFO,"crc of resulting file %hu does not match official %hu",
			mycrc,theircrc);
	else if (rc == 5)
		syslog(LOG_INFO,"unknown command line: \"%s\"",cmdbuf);
	else if (rc == 6)
		syslog(LOG_INFO,"diff does not match old list");
	else
		syslog(LOG_INFO,"copied %d, added %d, deleted %d, difference %d, rc=%d",
			cc,ac,dc,ac-dc,rc);
	return rc;
}
