/*
	$Id: ttyio.h,v 1.2 1999/12/20 21:53:46 crosser Exp $
*/

/*
	"ifmail": FidoNet(r) support package for UN*X platform

	Copyright (c) 1993-1999 Eugene G. Crosser

	You may distribute and/or use for any purpose modified or unmodified
	copies of this software if you preserve the copyright notice above.

	THIS SOFTWARE IS PROVIDED AS IS AND COME WITH NO WARRANTY OF ANY
	KIND, EITHER EXPRESSED OR IMPLIED.  IN NO EVENT WILL THE
	COPYRIGHT HOLDER BE LIABLE FOR ANY DAMAGES RESULTING FROM THE
	USE OF THIS SOFTWARE.

	URL: http://www.average.org/ifmail/
	E-Mail: <crosser@average.org>
*/

/*
	$Log: ttyio.h,v $
	Revision 1.2  1999/12/20 21:53:46  crosser
	Added Janus implementation by Kolya Nesterov, 2:463/567@fidonet
	(patch for 3.02 made by Vladimir Zarozhevsky)
	
	Revision 1.1.1.1  1999/08/29 22:53:46  crosser
	Ifmail
	
*/
#ifndef TTYIO_H
#define TTYIO_H

#define RESETTIMERN(x) tty_resettimern(x)
#define RESETTIMER() tty_resettimer()
#define SETTIMER(x,y) tty_settimer(x,y)
#define EXPIRED(x) tty_expired(x)
#define RUNNING(x) tty_running(x)
#define FLUSHOUT() tty_flushout()
#define FLUSHIN() tty_flushin()

#define CHECK() tty_check()
#define PUTCHAR(x) tty_putc(x)
#define PUT(x,y) tty_put(x,y)
#define PUTSTR(x) tty_put(x,strlen(x))
#define GETCHAR(x) tty_getc(x)
#define GET(x,y,z) tty_get(x,y,z)
#define PUTGET(a,b,x,y) tty_putget(a,b,x,y)
#define STATUS tty_status

#define STAT_SUCCESS 0
#define STAT_ERROR   1
#define STAT_TIMEOUT 2
#define STAT_EOFILE  3
#define STAT_HANGUP  4
#define STAT_EMPTY   5

#define SUCCESS (STATUS == 0)
#define ERROR (-STAT_ERROR)
#define TIMEOUT (-STAT_TIMEOUT)
#define EOFILE (-STAT_EOFILE)
#define HANGUP (-STAT_HANGUP)
#define EMPTY (-STAT_EMPTY)

#define GET_COMPLETE(x) (x & 1)
#define PUT_COMPLETE(x) (x & 2)

#define NUL 0x00
#define SOH 0x01
#define STX 0x02
#define ETX 0x03
#define EOT 0x04
#define ENQ 0x05
#define ACK 0x06
#define BEL 0x07
#define BS  0x08
#define HT  0x09
#define LF  0x0a
#define VT  0x0b
#define FF  0x0c
#define CR  0x0d
#define SO  0x0e
#define SI  0x0f
#define DLE 0x10
#define DC1 0x11
#define DC2 0x12
#define DC3 0x13
#define DC4 0x14
#define NAK 0x15
#define SYN 0x16
#define ETB 0x17
#define CAN 0x18
#define EM  0x19
#define SUB 0x1a
#define ESC 0x1b
#define FS  0x1c
#define GS  0x1d
#define RS  0x1e
#define US  0x1f
#define TSYNC 0xae
#define YOOHOO 0xf1

extern int tty_status;

extern int tty_check(void);
extern int tty_getc(int);
extern int tty_get(char*,int,int);
extern int tty_putc(int);
extern int tty_put(char*,int);
extern int tty_putget(char**,int*,char**,int*);
extern void sendbrk(void);
extern int tty_resettimern(int tno);
extern void tty_resettimer(void);
extern int tty_settimer(int,int);
extern int tty_expired(int);
extern int tty_running(int);
extern void tty_flushout(void);
extern void tty_flushin(void);

#endif
