#ifndef LINT
static char *rcsid="$Id: txy.c,v 1.1 2000/04/14 04:51:42 crosser Exp $";
#endif

/*
 * Copyright (c) 1995 Boris V. Tobotras
 * boris@xtalk.msk.su AKA 2:5020/20.7 AKA 2:5020/188.21
 *
 * Created: Fri Feb  3 14:28:16 1995
 *
 * Txy flag (FSC-0069?) processing functions for ifcico
 *
 * Consider code below as freeware, please.
 *
 */

/*
	$Log: txy.c,v $
	Revision 1.1  2000/04/14 04:51:42  crosser
	added forgotten file
	
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <sys/types.h>
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif
#ifdef HAVE_CTYPE_H
# include <ctype.h>
#endif

#include "lutil.h"
#include "session.h"

static int isnodecallable(xy)
char *xy;
{
	time_t GMTime = time(NULL);
	struct tm *Now = gmtime(&GMTime);
	int NowMin = Now->tm_hour * 60 + Now->tm_min;
	int WorkTimeStartMin = (toupper(*xy) - 'A') * 60,
		WorkTimeEndMin;
	if (islower(*xy++))
		WorkTimeStartMin += 30;
	WorkTimeEndMin = (toupper(*xy) - 'A') * 60;
	if (islower(*xy))
		WorkTimeEndMin += 30;
	debug(10, "Working time: %02d:%02d-%02d:%02d, now %02d:%02d GMT",
		WorkTimeStartMin / 60, WorkTimeStartMin % 60,
		WorkTimeEndMin / 60, WorkTimeEndMin % 60,
		NowMin / 60, NowMin % 60);

	if (WorkTimeEndMin == WorkTimeStartMin)
		return 1;
	
	if (WorkTimeEndMin > WorkTimeStartMin) {
		if (NowMin >= WorkTimeStartMin && NowMin < WorkTimeEndMin)
			return 1;
		else
			return 0;
	} else {
		if (NowMin >= WorkTimeStartMin || NowMin < WorkTimeEndMin)
			return 1;
		else
			return 0;
	}
}

/*
 * Checks nodelist entry against U,Txy flag and determines
 * whether node can be dialed. If one not present, assumes
 * 'no'. If Txy found, checks it against current time.
 * Returns: 0 if system should NOT be called, 1 otherwise.
 */
int istxy(nlent)
node *nlent;
{
	int i;

	for (i = 0; i < MAXUFLAGS; ++i) {
		char *flag = nlent->uflags[i];
		if (flag) {
			if (flag[0] == 'U' && flag[1] == 'T') flag++;
			if (flag[0] == 'T' && flag[3] == '\0') {
				if ((toupper(flag[1]) >= 'A' && toupper(flag[1]) <= 'X')
					&& (toupper(flag[2]) >= 'A' && toupper(flag[2]) <= 'X')) {
					debug(10, "Found Txy flag: %s", flag++);
					return (isnodecallable(flag));
				} else {
					debug(10, "Bad Txy flag: %s", flag);
					break;
				}
			}
		}
		else
			break;
	}
	debug(10, "No Txy flag");
	return (0);
}
