#ifndef LINT
static char *rcsid="$Id: batchrd.c,v 1.2 1999/12/28 16:01:54 crosser Exp $";
#endif

/*
	"ifmail": FidoNet(r) support package for UN*X platform

	Copyright (c) 1993-1999 Eugene G. Crosser

	You may distribute and/or use for any purpose modified or unmodified
	copies of this software if you preserve the copyright notice above.

	THIS SOFTWARE IS PROVIDED AS IS AND COME WITH NO WARRANTY OF ANY
	KIND, EITHER EXPRESSED OR IMPLIED.  IN NO EVENT WILL THE
	COPYRIGHT HOLDER BE LIABLE FOR ANY DAMAGES RESULTING FROM THE
	USE OF THIS SOFTWARE.

	URL: http://www.average.org/ifmail/
	E-Mail: <crosser@average.org>
*/

/*
	$Log: batchrd.c,v $
	Revision 1.2  1999/12/28 16:01:54  crosser
	Move to syslog
	Portability for HP/UX
	
	Revision 1.1.1.1  1999/08/29 22:53:45  crosser
	Ifmail
	
*/

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <sys/types.h>
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif
#include <stdio.h>
#ifdef STDC_HEADERS
# include <stdlib.h>
# include <string.h>
#else
# ifdef HAVE_STRINGS_H
#  include <strings.h>
# endif
#endif
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif

#include <stdio.h>
#include <string.h>
#include "lutil.h"

static long counter = 0L;
static int batchmode = -1;
extern int usetmp;

/* Warning: this function modifies passed buffer in place */
static char *removecr(buf)
char *buf;
{
	char *p;

	if (!buf) return NULL;
	p=buf+strlen(buf)-2;
	if ((*p == '\r') && (*(p+1) == '\n')) {
		*p='\n';
		*(p+1)='\0';
	}
	return buf;
}

char *bgets(buf,count,fp)
char *buf;
int count;
FILE *fp;
{
	if (usetmp)
	{
		return removecr(fgets(buf,count,fp));
	}

	if ((batchmode == 1) && (counter > 0L) && (counter < (long)(count-1))) 
		count=(int)(counter+1L);
	if (fgets(buf,count,fp) == NULL) return NULL;
	switch (batchmode)
	{
	case -1: if (!strncmp(buf,"#! rnews ",9) || !strncmp(buf,"#!rnews ",8))
		{
			batchmode=1;
			sscanf(buf+8,"%ld",&counter);
			debug(18,"first chunk of input batch: %ld",counter);
			if (counter < (long)(count-1)) count=(int)(counter+1L);
			if (fgets(buf,count,fp) == NULL) return NULL;
			else
			{
				counter -= strlen(buf);
				return removecr(buf);
			}
		}
		else
		{
			batchmode=0;
			return removecr(buf);
		}

	case 0:	return removecr(buf);

	case 1:	if (counter <= 0L)
		{
			while (strncmp(buf,"#! rnews ",9) &&
		    		strncmp(buf,"#!rnews ",8))
			{
				syslog(LOG_INFO,"batch out of sync: %s",buf);
				if (fgets(buf,count,fp) == NULL) return NULL;
			}
			sscanf(buf+8,"%ld",&counter);
			debug(18,"next chunk of input batch: %ld",counter);
			return NULL;
		}
		else
		{
			counter -= (long)strlen(buf);
			debug(19,"bread \"%s\", %ld left of this chunk",
				buf,counter);
			return removecr(buf);
		}
	}
	return removecr(buf);
}
