#ifndef LINT
static char *rcsid="$Id: iftoss.c,v 1.5 1999/12/28 16:01:54 crosser Exp $";
#endif

/*
	"ifmail": FidoNet(r) support package for UN*X platform

	Copyright (c) 1993-1999 Eugene G. Crosser

	You may distribute and/or use for any purpose modified or unmodified
	copies of this software if you preserve the copyright notice above.

	THIS SOFTWARE IS PROVIDED AS IS AND COME WITH NO WARRANTY OF ANY
	KIND, EITHER EXPRESSED OR IMPLIED.  IN NO EVENT WILL THE
	COPYRIGHT HOLDER BE LIABLE FOR ANY DAMAGES RESULTING FROM THE
	USE OF THIS SOFTWARE.

	URL: http://www.average.org/ifmail/
	E-Mail: <crosser@average.org>
*/

/*
	$Log: iftoss.c,v $
	Revision 1.5  1999/12/28 16:01:54  crosser
	Move to syslog
	Portability for HP/UX
	
	Revision 1.4  1999/11/26 18:11:36  crosser
	Tune for sunos4
	
	Revision 1.3  1999/09/12 11:05:55  crosser
	FAKEDIR related fixes
	
	Revision 1.2  1999/08/30 16:43:16  crosser
	Make the thing at least compile.
	
	Revision 1.1.1.1  1999/08/29 22:53:45  crosser
	Ifmail
	
*/

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <sys/types.h>
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif
#include <stdio.h>
#ifdef STDC_HEADERS
# include <stdlib.h>
# include <string.h>
#else
# ifdef HAVE_STRINGS_H
#  include <strings.h>
# endif
#endif
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif
#ifndef OPTARG_DEFINED
#include <getopt.h>
#endif
#ifdef HAVE_SYSLOG
#include <syslog.h>
#endif
#include "mygetopt.h"
#include "lutil.h"
#include "rdconfig.h"
#include "ftn.h"
#include "getheader.h"
#include "trap.h"

#ifndef FAKEDIR
#define FAKEDIR "/tmp/ifmail"
#endif

extern int getmessage(FILE *,faddr *,faddr *);
extern void readareas(char *);
extern void readalias(char *);
extern int exclose(FILE *);
extern void close_alias_db(void);
extern void mkdirs(char *);

extern int num_echo,num_mail;

int usetmp=1; /* to tell bgets that we do not use batch mode */
int notransports=0;

void usage(name)
char *name;
{
#ifdef RELAXED
	confusage("-N");
	fprintf(stderr,"-N		put messages to %s directory\n",
						FAKEDIR);
#else
	confusage("-N -f");
	fprintf(stderr,"-N		put messages to %s directory\n",
						FAKEDIR);
	fprintf(stderr,"-f		force tossing of packets addressed to other nodes\n");
#endif
}

FILE *nb = NULL;

int main(argc,argv)
int argc;
char *argv[];
{
	int c;
	int rc,maxrc;
#ifdef RELAXED
	int relaxed=1;
#else
	int relaxed=0;
#endif
	faddr from,to;

#if defined(HAVE_SYSLOG) && defined(MAILLOG)
	logfacility=MAILLOG;
#endif

	setmyname(argv[0]);
	catch(myname);
#ifdef RELAXED
	while ((c=getopt(argc,argv,"Nhx:I:")) != -1)
#else
	while ((c=getopt(argc,argv,"Nfhx:I:")) != -1)
#endif
	if (confopt(c,optarg)) switch (c)
	{
		case 'N':	notransports=1; break;
#ifndef RELAXED
		case 'f':	relaxed=1; break;
#endif
		default:	usage(argv[0]); exit(1);
	}

	if (readconfig())
	{
		syslog(LOG_ERR,"Error getting configuration, aborting");
		exit(1);
	}

	readareas(areafile);
	readalias(aliasfile);

	if (notransports)
	{
		mkdirs(FAKEDIR "/");
		syslog(LOG_INFO,"messages/newsbatches will go to %s",FAKEDIR);
	}

#ifdef PARANOID
	if (((rc=getheader(&from,&to,stdin)) != 0) &&
	    ((rc != 3) || (!relaxed)))
#else
	if (((rc=getheader(&from,&to,stdin)) != 0) &&
	    ((rc != 3) || (!relaxed)) &&
	    (rc != 4))
#endif
	{
		syslog(LOG_ERR,"%s, aborting",(rc==3)?"packet not to this node":
			(rc==4)?"bad password":"bad packet");
		exit(rc);
	}

	while ((rc=getmessage(stdin,&from,&to)) == 1);

	maxrc=rc;

	if (nb)
	{
		if (notransports) rc=fclose(nb);
		else rc=exclose(nb);
		if (rc < 0) rc=10-rc;
		if (rc > maxrc) maxrc=rc;
	}

	close_alias_db();

	syslog(LOG_INFO,"end %d echomail, %d netmail messages processed, rc=%d",
		num_echo,num_mail,maxrc);

	return maxrc;
}
