#ifndef LINT
static char *rcsid="$Id: bread.c,v 1.1.1.1 1999/08/29 22:53:45 crosser Exp $";
#endif

/*
	"ifmail": FidoNet(r) support package for UN*X platform

	Copyright (c) 1993-1999 Eugene G. Crosser

	You may distribute and/or use for any purpose modified or unmodified
	copies of this software if you preserve the copyright notice above.

	THIS SOFTWARE IS PROVIDED AS IS AND COME WITH NO WARRANTY OF ANY
	KIND, EITHER EXPRESSED OR IMPLIED.  IN NO EVENT WILL THE
	COPYRIGHT HOLDER BE LIABLE FOR ANY DAMAGES RESULTING FROM THE
	USE OF THIS SOFTWARE.

	URL: http://www.average.org/ifmail/
	E-Mail: <crosser@average.org>
*/

/*
	$Log: bread.c,v $
	Revision 1.1.1.1  1999/08/29 22:53:45  crosser
	Ifmail
	
*/

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <sys/types.h>
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif
#include <stdio.h>
#ifdef STDC_HEADERS
# include <stdlib.h>
# include <string.h>
#else
# ifdef HAVE_STRINGS_H
#  include <strings.h>
# endif
#endif
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif

#include <stdio.h>
#include "bread.h"
#include "rdconfig.h"

/* read short (16bit) integer in "standart" byte order */
int iread(fp)
FILE *fp;
{
	unsigned char lo,hi;

	fread(&lo,1,1,fp);
	fread(&hi,1,1,fp);
	return (hi<<8) | lo;
}

/* read long (32bit) integer in "standart" byte order */
long lread(fp)
FILE *fp;
{
	int c;
	unsigned char buf;
	long ret=0L;

	for (c=0;c<32;c+=8)
	{
		fread(&buf,1,1,fp);
		ret |= ((unsigned long)buf << c);
	}
	return ret;
}

static int at_zero=0;

char *aread(s,count,fp)
char *s;
int count;
FILE *fp;
{
	int i,c,next;

	if (feof(fp)) return(NULL);
	if (s == NULL) return NULL;
	if (at_zero)
	{
		at_zero=0;
		return NULL;
	}

	for (i=0,next=1;(i<count-1) && next;)
	switch (c=getc(fp))
	{
	case '\n':	break;
	case '\r':	s[i]='\n';
			i++;
			next=0;
			break;
	case 0x8d:	s[i]=' ';
			i++;
			break;
	case '\0':	at_zero=1;
			next=0;
			break;
	default:	s[i]=intab[c];
			i++;
			break;
	}
	s[i]='\0';
	return s;
}
