#ifndef LINT
static char *rcsid="$Id: bwrite.c,v 1.1.1.1 1999/08/29 22:53:45 crosser Exp $";
#endif

/*
	"ifmail": FidoNet(r) support package for UN*X platform

	Copyright (c) 1993-1999 Eugene G. Crosser

	You may distribute and/or use for any purpose modified or unmodified
	copies of this software if you preserve the copyright notice above.

	THIS SOFTWARE IS PROVIDED AS IS AND COME WITH NO WARRANTY OF ANY
	KIND, EITHER EXPRESSED OR IMPLIED.  IN NO EVENT WILL THE
	COPYRIGHT HOLDER BE LIABLE FOR ANY DAMAGES RESULTING FROM THE
	USE OF THIS SOFTWARE.

	URL: http://www.average.org/ifmail/
	E-Mail: <crosser@average.org>
*/

/*
	$Log: bwrite.c,v $
	Revision 1.1.1.1  1999/08/29 22:53:45  crosser
	Ifmail
	
*/

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <sys/types.h>
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif
#include <stdio.h>
#ifdef STDC_HEADERS
# include <stdlib.h>
# include <string.h>
#else
# ifdef HAVE_STRINGS_H
#  include <strings.h>
# endif
#endif
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif

#include <stdio.h>
#include "bwrite.h"
#include "rdconfig.h"

/* write short (16bit) integer in "standart" byte order */
int iwrite(i,fp)
int i;
FILE *fp;
{
	putc(i & 0xff,fp);
	putc((i >> 8) & 0xff,fp);
	return 0;
}

/* write long (32bit) integer in "standart" byte order */
int lwrite(i,fp)
long i;
FILE *fp;
{
	int c;

	for (c=0;c<32;c+=8) putc((i >> c) & 0xff,fp);
	return 0;
}

int awrite(s,fp)
char *s;
FILE *fp;
{
	if (s) while (*s) putc(outtab[*(s++) & 0xff], fp);
	putc(0,fp);
	return 0;
}

/* write an arbitrary line to message body: change \n to \r\n */
int cwrite(s,fp)
char *s;
FILE *fp;
{
	while (*s) 
	{
		if (*s == '\n') putc('\r',fp);
		else putc(outtab[*s & 0xff],fp);
		s++;
	}
	return 0;
}

/* write (multiline) header to kluge: change \n to ' ' and end line with \r */
int kwrite(s,fp)
char *s;
FILE *fp;
{
	while (*s) 
	{
		if (*(unsigned char*)s >= ' ')
			putc(outtab[*s & 0xff],fp);
		else switch (*s) {
		case '\r':
			if (*(s+1)) fprintf(fp,"\\r");
			break;
		case '\n':
			if (*(s+1)) fprintf(fp,"\\n");
			break;
		case '\\':
			fprintf(fp,"\\\\");
			break;
		case '\t':
			fprintf(fp,"\\t");
			break;
		case '\b':
			fprintf(fp,"\\b");
			break;
		default:
			fprintf(fp,"\\%03o",*(unsigned char*)s);
			break;
		}
		s++;
	}
	putc('\r',fp);
	return 0;
}
