#ifndef LINT
static char *rcsid="$Id: callstat.c,v 1.3 1999/12/29 23:16:54 crosser Exp $";
#endif

/*
	"ifmail": FidoNet(r) support package for UN*X platform

	Copyright (c) 1993-1999 Eugene G. Crosser

	You may distribute and/or use for any purpose modified or unmodified
	copies of this software if you preserve the copyright notice above.

	THIS SOFTWARE IS PROVIDED AS IS AND COME WITH NO WARRANTY OF ANY
	KIND, EITHER EXPRESSED OR IMPLIED.  IN NO EVENT WILL THE
	COPYRIGHT HOLDER BE LIABLE FOR ANY DAMAGES RESULTING FROM THE
	USE OF THIS SOFTWARE.

	URL: http://www.average.org/ifmail/
	E-Mail: <crosser@average.org>
*/

/*
	$Log: callstat.c,v $
	Revision 1.3  1999/12/29 23:16:54  crosser
	make syslog and debug use %m for error message
	
	Revision 1.2  1999/12/28 16:01:55  crosser
	Move to syslog
	Portability for HP/UX
	
	Revision 1.1.1.1  1999/08/29 22:53:45  crosser
	Ifmail
	
*/

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <sys/types.h>
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif
#include <stdio.h>
#ifdef STDC_HEADERS
# include <stdlib.h>
# include <string.h>
#else
# ifdef HAVE_STRINGS_H
#  include <strings.h>
# endif
#endif
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif

#include <sys/types.h>
#include <time.h>
#include <stdio.h>
#include "lutil.h"
#include "ftn.h"
#include "callstat.h"

extern char *stsname(faddr *,char);

static callstat st;

callstat *getstatus(addr)
faddr *addr;
{
	FILE *fp;
	time_t now;

	st.trytime=0L;
	st.tryno=0;
	st.trystat=0;

	if ((fp=fopen(stsname(addr,'f'),"r")))
	{
		fscanf(fp,"%lu %u %u",&st.trytime,&st.tryno,&st.trystat);
		fclose(fp);
	}

	(void)time(&now);

	return &st;
}

void putstatus(addr,incr,sts)
faddr *addr;
int incr;
int sts;
{
	FILE *fp;

	(void)getstatus(addr);
	if ((fp=fopen(stsname(addr,'f'),"w")))
	{
		if (sts == 0) st.tryno=0;
		else st.tryno+=incr;
		st.trystat=sts;
		(void)time(&st.trytime);
		fprintf(fp,"%lu %u %u\n",
			st.trytime,st.tryno,(unsigned)st.trystat);
		fclose(fp);
	}
	else
	{
		syslog(LOG_ERR,"cannot create status file for node %s: %m",
			ascfnode(addr,0x1f));
	}
}
