#ifndef LINT
static char *rcsid="$Id: expipe.c,v 1.3 1999/12/29 23:16:54 crosser Exp $";
#endif

/*
	"ifmail": FidoNet(r) support package for UN*X platform

	Copyright (c) 1993-1999 Eugene G. Crosser

	You may distribute and/or use for any purpose modified or unmodified
	copies of this software if you preserve the copyright notice above.

	THIS SOFTWARE IS PROVIDED AS IS AND COME WITH NO WARRANTY OF ANY
	KIND, EITHER EXPRESSED OR IMPLIED.  IN NO EVENT WILL THE
	COPYRIGHT HOLDER BE LIABLE FOR ANY DAMAGES RESULTING FROM THE
	USE OF THIS SOFTWARE.

	URL: http://www.average.org/ifmail/
	E-Mail: <crosser@average.org>
*/

/*
	$Log: expipe.c,v $
	Revision 1.3  1999/12/29 23:16:54  crosser
	make syslog and debug use %m for error message
	
	Revision 1.2  1999/12/28 16:01:55  crosser
	Move to syslog
	Portability for HP/UX
	
	Revision 1.1.1.1  1999/08/29 22:53:45  crosser
	Ifmail
	
*/

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <sys/types.h>
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif
#include <stdio.h>
#ifdef STDC_HEADERS
# include <stdlib.h>
# include <string.h>
#else
# ifdef HAVE_STRINGS_H
#  include <strings.h>
# endif
#endif
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif

#include <sys/types.h>
#include <errno.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/wait.h>
#include "lutil.h"

static struct _fppid {
	FILE *fp;
	int pid;
} fppid[] = {
	{NULL,0},
	{NULL,0},
	{NULL,0}
};
#define maxfppid 2

FILE *expipe(cmd,from,to)
char *cmd,*from,*to;
{
	char buf[256],*buflimit;
	char *vector[16];
	int i,rc;
	char *p,*q,*f=from,*t=to;
	int pipedes[2];
	FILE *fp;
	int pid,slot;

	buflimit=buf+sizeof(buf)-1-
		(f&&t&&(strlen(f)>strlen(t))?strlen(f):t?strlen(t):0);

	for (slot=0;slot<=maxfppid;slot++) {
		if (fppid[slot].fp == NULL) break;
	}
	if (slot > maxfppid) {
		syslog(LOG_ERR,"attemt to pipe more than %d processes",maxfppid + 1);
		return NULL;
	}

	for (p=cmd,q=buf;(*p);p++) {
		if (q > buflimit) {
			syslog(LOG_ERR,"attemt to pipe too long command");
			return NULL;
		}
		switch (*p) {
		case '$':	switch (*(++p))
				{
				case 'f':
				case 'F': if ((f)) while (*f) *(q++)=*(f++);
					f=from; break;
				case 't':
				case 'T': if ((t)) while (*t) *(q++)=*(t++);
					t=to; break;
				default: *(q++)='$'; *(q++)=*p; break;
				}
				break;
		case '\\':	*(q++)=*(++p); break;
		default: *(q++)=*p; break;
		}
	}
	*q='\0';
	syslog(LOG_INFO,"Expipe: %s",buf);
	i=0;
	vector[i++]=strtok(buf," \t\n");
	while ((vector[i++]=strtok(NULL," \t\n")) && (i<16));
	vector[15]=NULL;
	fflush(stdout);
	fflush(stderr);
	if (pipe(pipedes) != 0) {
		syslog(LOG_ERR,"pipe failed for command \"%s\": %m",S(vector[0]));
		return NULL;
	}
	debug(2,"pipe() returned %d,%d",pipedes[0],pipedes[1]);
	if ((pid=fork()) == 0) {
		close(pipedes[1]);
		close(0);
		if (dup(pipedes[0]) != 0) {
			syslog(LOG_ERR,"Reopen of stdin for command %s failed: %m",
				S(vector[0]));
			exit(-1);
		}
		rc=execv(vector[0],vector);
		syslog(LOG_ERR,"Exec \"%s\" returned %d: %m",S(vector[0]),rc);
		exit(-1);
	}
	close(pipedes[0]);
	if ((fp=fdopen(pipedes[1],"w")) == NULL) {
		syslog(LOG_ERR,"fdopen failed for pipe to command \"%s\": %m",
			S(vector[0]));
	}
	fppid[slot].fp=fp;
	fppid[slot].pid=pid;
	return fp;
}

int exclose(fp)
FILE *fp;
{
	int status,rc;
	int pid,slot,sverr;

	for (slot=0;slot<=maxfppid;slot++) {
		if (fppid[slot].fp == fp) break;
	}
	if (slot > maxfppid) {
		syslog(LOG_ERR,"attempt to close unopened pipe");
		return -1;
	}
	pid=fppid[slot].pid;
	fppid[slot].fp=NULL;
	fppid[slot].pid=0;

	debug(2,"closing pipe to the child process %d",pid);
	if ((rc=fclose(fp)) != 0) {
		syslog(LOG_ERR,"error closing pipe to transport (rc=%d): %m",rc);
		if ((rc=kill(pid,SIGKILL)) != 0)
			syslog(LOG_ERR,"kill for pid %d returned %d: %m",pid,rc);
	}
	debug(2,"waiting for process %d to finish",pid);
	do {
		rc=wait(&status);
		sverr=errno;
		debug(2,"Wait returned %d, status %d,%d: %m",
			rc,status>>8,status&0xff);
	} while (((rc > 0) && (rc != pid)) || ((rc == -1) && (sverr == EINTR)));
	if (rc == -1) {
		syslog(LOG_ERR,"Wait returned %d, status %d,%d: %m",
			rc,status>>8,status&0xff);
		return -1;
	}
	debug(2,"status=%d",status);
	return status;
}
