#ifndef LINT
static char *rcsid="$Id: matchaka.c,v 1.1.1.1 1999/08/29 22:53:45 crosser Exp $";
#endif

/*
	"ifmail": FidoNet(r) support package for UN*X platform

	Copyright (c) 1993-1999 Eugene G. Crosser

	You may distribute and/or use for any purpose modified or unmodified
	copies of this software if you preserve the copyright notice above.

	THIS SOFTWARE IS PROVIDED AS IS AND COME WITH NO WARRANTY OF ANY
	KIND, EITHER EXPRESSED OR IMPLIED.  IN NO EVENT WILL THE
	COPYRIGHT HOLDER BE LIABLE FOR ANY DAMAGES RESULTING FROM THE
	USE OF THIS SOFTWARE.

	URL: http://www.average.org/ifmail/
	E-Mail: <crosser@average.org>
*/

/*
	$Log: matchaka.c,v $
	Revision 1.1.1.1  1999/08/29 22:53:45  crosser
	Ifmail
	
*/

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <sys/types.h>
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif
#include <stdio.h>
#ifdef STDC_HEADERS
# include <stdlib.h>
# include <string.h>
#else
# ifdef HAVE_STRINGS_H
#  include <strings.h>
# endif
#endif
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif

#include <stdlib.h>
#include <string.h>
#include "ftn.h"
#include "lutil.h"
#include "rdconfig.h"

int metric(a1,a2)
faddr *a1,*a2;
{
	if ((a1->domain != NULL) &&
	    (a2->domain != NULL) &&
	    (strcasecmp(a1->domain,a2->domain) != 0))
		return METRIC_DOMAIN;
	if ((a1->zone != 0) && (a2->zone != 0) &&
	    (a1->zone != a2->zone))  return METRIC_ZONE;
	if (a1->net   != a2->net)   return METRIC_NET;
	if (a1->node  != a2->node)  return METRIC_NODE;
	if (a1->point != a2->point) return METRIC_POINT;
	return METRIC_EQUAL;
}

faddr *bestaka_s(addr)
faddr *addr;
{
	fa_list *tmp;
	faddr *best;
	int minmetric,wt;

	debug(6,"bestaka_s for %s",ascfnode(addr,0x1f));
	best=whoami->addr;
	if (addr == NULL) return best;
	minmetric=metric(addr,best);
	for (tmp=whoami;tmp;tmp=tmp->next)
	{
		wt=metric(addr,tmp->addr);
		debug(6,"addr %s metric %d",ascfnode(tmp->addr,0x1f),wt);
		if ((wt < minmetric) &&
		    ((best->point != 0) || (minmetric > METRIC_NODE)))
		/* In the same network, use node address even when routing
		   to the node where we have a point address */
		{
			debug(6,"setting best");
			minmetric=wt;
			best=tmp->addr;
		}
	}
	debug(6,"bestaka_s is  %s",ascfnode(best,0x1f));
	return best;
}

int is_local(addr)
faddr *addr;
{
	fa_list *tmp;

	for (tmp=whoami;tmp;tmp=tmp->next)
	{
		if (metric(tmp->addr,addr) == METRIC_EQUAL)
			return 1; /* yes */
	}
	return 0; /* no */
}
